/*
 * Copyright (c) 2000, 2001 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Clack.
 * 
 * Clack is free software, also known as "open source."  You can redistribute
 * it and/or modify it under the terms of the GNU General Public License
 * (GPL), version 2, as published by the Free Software Foundation (FSF).
 * 
 * Clack is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GPL for more details.  You should have
 * received a copy of the GPL along with Clack; see the file COPYING.  If
 * not, write to the FSF, 59 Temple Place #330, Boston, MA 02111-1307, USA.
 * 
 * Clack is modelled on and includes some code fragments from MIT's Click
 * system (http://www.pdos.lcs.mit.edu/click/) which is copyright (c)
 * 1999-2000 Massachusetts Institute of Technology and also GPL'ed.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */

#include <clack/c/packet.h>
#include <clack/c/packet_ip.h>
#include <arpa/inet.h>

clack_size_t size; // mtu

extern clack_error_t push_in(clack_packet_t *p);
       clack_error_t push   (clack_packet_t *p);

clack_error_t push(clack_packet_t *p)
{
#if 0 // ToDo: convert fragmenting code from C++
        // ToDo: At this point, we've already checked that we can and must fragment
        // but, all the same, this code should work even if we didn't check.
        struct ip *ip = (struct ip *) clack_packet_data(p);
        clack_size_t length = clack_packet_length(p);
        
        int hlen = ip->ip_hl << 2;
        int len = (size - hlen) & ~7;
        int ipoff = ntohs(ip->ip_off);
      
        int olen = optcopy(ip, (click_ip *)0);
        int h1len = sizeof(*ip) + olen;
        int plen = ntohs(ip->ip_len);
        int off;
      
        for(off = hlen + len; off < plen; off += len){
                int p1datalen = plen - off;
                if (p1datalen > len)
                        p1datalen = len;
                int p1len = p1datalen + h1len;
                Packet *p1 = Packet::make(p1len);
                click_ip *ip1 = (click_ip *) p1->data();
                
                *ip1 = *ip;
                optcopy(ip, ip1);
                
                assert(off + p1datalen <= (int)p->length());
                memcpy(p1->data() + h1len, p->data() + off, p1datalen);
                
                ip1->ip_hl = h1len >> 2;
                ip1->ip_off = ((off - hlen) >> 3) + (ipoff & IP_OFFMASK);
                if(ipoff & IP_MF)
                        ip1->ip_off |= IP_MF;
                if(off + p1datalen < plen)
                        ip1->ip_off |= IP_MF;
                ip1->ip_off = htons(ip1->ip_off);
                ip1->ip_len = htons(p1len);
                ip1->ip_sum = 0;
                ip1->ip_sum = in_cksum(p1->data(), h1len);
                
                p1->copy_annotations(p);
                p1->set_ip_header(ip1);
                push_in(p1);
        }
        // XXX alignment???
        p = p->take(p->length() - (hlen + len));
        ip = (click_ip *) p->data();
        ip->ip_len = htons(hlen + len);
        ip->ip_off = htons(ipoff | IP_MF);
        ip->ip_sum = 0;
        ip->ip_sum = in_cksum((unsigned char *) ip, hlen);
        p->set_ip_header(ip);
#endif

        push_in(p);
        return 0;
}

