/*
 * Copyright (c) 2000, 2001 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Clack.
 * 
 * Clack is free software, also known as "open source."  You can redistribute
 * it and/or modify it under the terms of the GNU General Public License
 * (GPL), version 2, as published by the Free Software Foundation (FSF).
 * 
 * Clack is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GPL for more details.  You should have
 * received a copy of the GPL along with Clack; see the file COPYING.  If
 * not, write to the FSF, 59 Temple Place #330, Boston, MA 02111-1307, USA.
 * 
 * Clack is modelled on and includes some code fragments from MIT's Click
 * system (http://www.pdos.lcs.mit.edu/click/) which is copyright (c)
 * 1999-2000 Massachusetts Institute of Technology and also GPL'ed.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */

#include <clack/c/packet.h>
#include <arpa/inet.h> /* htons */

extern clack_u32_t offset;
extern clack_u16_t value2;
extern clack_u16_t mask2;

static clack_u16_t _value;
static clack_u16_t _mask;

clack_error_t init(void) 
{
        _value = htons(value2);
        _mask  = htons(mask2);
        return 0;
}

int pred(clack_packet_t *p)
{
        void* d = clack_packet_data(p);
        clack_size_t l = clack_packet_length(p);

        return (offset+1 < l && (*(clack_u16_t*)(d+offset) & _mask) == _value);
}
